;** ###################################################################
;**     This code is generated by the Device Initialization Tool.
;**     It is overwritten during code generation.
;**     USER MODIFICATION ARE PRESERVED ONLY INSIDE INTERRUPT SERVICE ROUTINES
;**     OR EXPLICITLY MARKED SECTIONS
;**
;**     Project   : js16_vga2
;**     Processor : MC9S08JS16CWJ
;**     Version   : Component 01.000, Driver 01.06, CPU db: 3.00.014
;**     Datasheet : MC9S08JS16RM Rev. 4 4/2009
;**     Date/Time : 9.8.2011, 15:31
;**     Abstract  :
;**         This module contains device initialization code 
;**         for selected on-chip peripherals.
;**     Contents  :
;**         Function "MCU_init" initializes selected peripherals
;**
;**     Copyright : 1997 - 2009 Freescale Semiconductor, Inc. All Rights Reserved.
;**     
;**     http      : www.freescale.com
;**     mail      : support@freescale.com
;** ###################################################################

; MODULE MCUinit

        INCLUDE MC9S08JS16.inc         ; I/O map for MC9S08JS16CWJ

; User declarations and definitions
;   Code, declarations and definitions here will be preserved during code generation
; End of user declarations and definitions

CODE_SECT:      SECTION

        XDEF    MCU_init
;** ===================================================================
;**     Method      :  MCU_init (component MC9S08JS16_20)
;**
;**     Description :
;**         Device initialization code for selected peripherals.
;** ===================================================================
MCU_init:
  ; ### MC9S08JS16_20 "Cpu" init code ... 

  ; Common initialization of the write once registers 
        ; SOPT1: COPT=0,STOPE=0,BLMSS=0,BKGDPE=1,RSTPE=0 
        LDA     #$12
        STA     SOPT1                                               
        ; SOPT2: COPCLKS=0,COPW=0,SPIFE=1 
        LDA     #$04
        STA     SOPT2                                               
        ; SPMSC1: LVWF=0,LVWACK=0,LVWIE=0,LVDRE=1,LVDSE=1,LVDE=1 
        LDA     #$1C
        STA     SPMSC1                                               
        ; SPMSC2: LVDV=0,LVWV=0,PPDF=0,PPDACK=0,PPDC=0 
        CLRA
        STA     SPMSC2                                               
  ;  System clock initialization 
        ;Test if the device trim value is stored on the specified address
        LDA     $FFAF
        CBEQA   #$FF, SkipTrim
        ; MCGTRM: Initialize internal clock trim from a non volatile memory 
        LDA     $FFAF
        STA     MCGTRM
        ; MCGSC: Initialize internal clock trim from a non volatile memory 
        LDA     $FFAE
        STA     MCGSC
SkipTrim:
        ; MCGC2: BDIV=0,RANGE=1,HGO=1,LP=0,EREFS=1,ERCLKEN=0,EREFSTEN=0 
        MOV     #$34,MCGC2             ; Set MCGC2 register 
        ; MCGC1: CLKS=2,RDIV=7,IREFS=0,IRCLKEN=0,IREFSTEN=0 
        MOV     #$B8,MCGC1             ; Set MCGC1 register 
while_Cpu0:                            ; Wait until external reference is stable 
        LDA     #85                    ; Reset watchdog counter - 2x write
        STA     SRS
        LDA     #170
        STA     SRS
        BRCLR   1,MCGSC,while_Cpu0
whileSet_Cpu0:                         ; Wait until external reference is selected 
        LDA     #85                    ; Reset watchdog counter - 2x write
        STA     SRS
        LDA     #170
        STA     SRS
        BRSET   4,MCGSC,whileSet_Cpu0
whileVal_Cpu0:                         ; Wait until external clock is selected as a bus clock reference 
        LDA     #85                    ; Reset watchdog counter - 2x write
        STA     SRS
        LDA     #170
        STA     SRS
        LDA     MCGSC
        AND     #$0C
  CMP          #$08
        BNE     whileVal_Cpu0
        ; MCGC2: BDIV=0,RANGE=1,HGO=1,LP=1,EREFS=1,ERCLKEN=0,EREFSTEN=0 
        MOV     #$3C,MCGC2             ; Set MCGC2 register 
        ; MCGC1: CLKS=2,RDIV=3,IREFS=0,IRCLKEN=0,IREFSTEN=0 
        MOV     #$98,MCGC1             ; Set MCGC1 register 
        ; MCGC3: LOLIE=0,PLLS=1,CME=0,VDIV=8 
        MOV     #$48,MCGC3             ; Set MCGC3 register 
        ; MCGC2: LP=0 
        BCLR    $03,MCGC2
while_Cpu1:                            ; Wait until PLL is selected 
        LDA     #85                    ; Reset watchdog counter - 2x write
        STA     SRS
        LDA     #170
        STA     SRS
        BRCLR   5,MCGSC,while_Cpu1
while_Cpu2:                            ; Wait until PLL is locked 
        LDA     #85                    ; Reset watchdog counter - 2x write
        STA     SRS
        LDA     #170
        STA     SRS
        BRCLR   6,MCGSC,while_Cpu2
        ; MCGC1: CLKS=0,RDIV=3,IREFS=0,IRCLKEN=0,IREFSTEN=0 
        MOV     #$18,MCGC1             ; Set MCGC1 register 
whileVal_Cpu1:                         ; Wait until PLL clock is selected as a bus clock reference 
        LDA     #85                    ; Reset watchdog counter - 2x write
        STA     SRS
        LDA     #170
        STA     SRS
        LDA     MCGSC
        AND     #$0C
  CMP          #$0C
        BNE     whileVal_Cpu1
  
  ; Common initialization of the CPU registers 
        ; PTASE: PTASE7=0,PTASE6=0,PTASE5=0,PTASE4=0,PTASE3=0,PTASE2=0,PTASE1=0,PTASE0=0 
        CLRA
        STA     PTASE                                               
        ; PTBSE: PTBSE5=0,PTBSE4=0,PTBSE3=0,PTBSE2=0,PTBSE1=0 
        LDA     PTBSE
        AND     #$C1
        STA     PTBSE
        ; PTADS: PTADS7=0,PTADS6=0,PTADS5=0,PTADS4=1,PTADS3=1,PTADS2=1,PTADS1=0,PTADS0=0 
        LDA     #$1C
        STA     PTADS                                               
        ; PTBDS: PTBDS5=0,PTBDS4=0,PTBDS3=0,PTBDS2=0,PTBDS1=0 
        CLRA
        STA     PTBDS                                               
  ; ### Init_GPIO init code 
        ; PTADD: PTADD7=1,PTADD6=1,PTADD5=1,PTADD4=1,PTADD3=1,PTADD2=1,PTADD1=1,PTADD0=1 
        MOV     #$FF,PTADD                                        
  ; ### Init_COP init code 
        LDA     #$55
        STA     SRS                    ; Clear WatchDog counter - first part 
        LDA     #$AA
        STA     SRS                    ; Clear WatchDog counter - second part 
  ; ### 
        CLI                            ; Enable interrupts 
        RTS



; Initialization of the CPU registers in FLASH 

        ; CHECKSUMBYPASS: BIT=$FF 
        ORG     CHECKSUMBYPASS
        DC.B    $FF

        ; NVPROT: FPS7=1,FPS6=1,FPS5=1,FPS4=1,FPS3=1,FPS2=1,FPS1=1,FPDIS=1 
        ORG     NVPROT
        DC.B    $FF

        ; NVOPT: KEYEN=0,FNORED=1,SEC01=1,SEC00=0 
        ORG     NVOPT
        DC.B    $7E



        XREF    _Startup

; Interrupt vector table 
  ifndef UNASSIGNED_ISR
UNASSIGNED_ISR: EQU     $FFFF          ; unassigned interrupt service routine
  endif

        ORG     $FFC4                  ; Interrupt vector table
_vect:
        DC.W    UNASSIGNED_ISR         ; Int.no. 29 Vrtc (at FFC4)                  Unassigned
        DC.W    UNASSIGNED_ISR         ; Int.no. 28 VReserved28 (at FFC6)           Unassigned
        DC.W    UNASSIGNED_ISR         ; Int.no. 27 VReserved27 (at FFC8)           Unassigned
        DC.W    UNASSIGNED_ISR         ; Int.no. 26 Vmtim (at FFCA)                 Unassigned
        DC.W    UNASSIGNED_ISR         ; Int.no. 25 Vkeyboard (at FFCC)             Unassigned
        DC.W    UNASSIGNED_ISR         ; Int.no. 24 VReserved24 (at FFCE)           Unassigned
        DC.W    UNASSIGNED_ISR         ; Int.no. 23 VReserved23 (at FFD0)           Unassigned
        DC.W    UNASSIGNED_ISR         ; Int.no. 22 VReserved22 (at FFD2)           Unassigned
        DC.W    UNASSIGNED_ISR         ; Int.no. 21 Vscitx (at FFD4)                Unassigned
        DC.W    UNASSIGNED_ISR         ; Int.no. 20 Vscirx (at FFD6)                Unassigned
        DC.W    UNASSIGNED_ISR         ; Int.no. 19 Vscierr (at FFD8)               Unassigned
        DC.W    UNASSIGNED_ISR         ; Int.no. 18 VReserved18 (at FFDA)           Unassigned
        DC.W    UNASSIGNED_ISR         ; Int.no. 17 VReserved17 (at FFDC)           Unassigned
        DC.W    UNASSIGNED_ISR         ; Int.no. 16 VReserved16 (at FFDE)           Unassigned
        DC.W    UNASSIGNED_ISR         ; Int.no. 15 VReserved15 (at FFE0)           Unassigned
        DC.W    UNASSIGNED_ISR         ; Int.no. 14 VReserved14 (at FFE2)           Unassigned
        DC.W    UNASSIGNED_ISR         ; Int.no. 13 VReserved13 (at FFE4)           Unassigned
        DC.W    UNASSIGNED_ISR         ; Int.no. 12 VReserved12 (at FFE6)           Unassigned
        DC.W    UNASSIGNED_ISR         ; Int.no. 11 Vtpmovf (at FFE8)               Unassigned
        DC.W    UNASSIGNED_ISR         ; Int.no. 10 Vtpmch1 (at FFEA)               Unassigned
        DC.W    UNASSIGNED_ISR         ; Int.no.  9 Vtpmch0 (at FFEC)               Unassigned
        DC.W    UNASSIGNED_ISR         ; Int.no.  8 VReserved8 (at FFEE)            Unassigned
        DC.W    UNASSIGNED_ISR         ; Int.no.  7 Vusb (at FFF0)                  Unassigned
        DC.W    UNASSIGNED_ISR         ; Int.no.  6 VReserved6 (at FFF2)            Unassigned
        DC.W    UNASSIGNED_ISR         ; Int.no.  5 Vspi (at FFF4)                  Unassigned
        DC.W    UNASSIGNED_ISR         ; Int.no.  4 Vlol (at FFF6)                  Unassigned
        DC.W    UNASSIGNED_ISR         ; Int.no.  3 Vlvd (at FFF8)                  Unassigned
        DC.W    UNASSIGNED_ISR         ; Int.no.  2 Virq (at FFFA)                  Unassigned
        DC.W    UNASSIGNED_ISR         ; Int.no.  1 Vswi (at FFFC)                  Unassigned
        DC.W    _Startup               ; Int.no.  0 Vreset (at FFFE)                Reset vector




        END     ; MODULE MCUinit

;** ###################################################################
;**
;**     This file was created by Processor Expert 3.07 [04.34]
;**     for the Freescale HCS08 series of microcontrollers.
;**
;** ###################################################################
