# Copyright (c) 2011, Vojtech Salajka
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the Franticware nor the
#       names of its contributors may be used to endorse or promote products
#       derived from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL Vojtech Salajka BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES#
# LOSS OF USE, DATA, OR PROFITS# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

import sys

def write_sleepn(n, fm, fr):
    orign = n
    if n == 12 or n == 16 or n == 32 or n == 64 or n == 128 or n == 256 or n == 512 or n == 1024 or n == 2048 or n == 4096 or n == 8192 or n == 16384 or n == 32768:
        return
    if n < 12:
        fm.write("sleep"+str(n)+":    MACRO\n")
        for x in range(0, n):
            fm.write("    nop\n")
        fm.write("    ENDM\n")
        return
    n = n - 12
    fr.write("_sleep"+str(orign)+":\n")
    x = 32768
    while x >= 16:
        if n & x:
            fr.write("    jsr _sleep"+str(x)+"\n")
            n = n - x
        x = int(x / 2)
    if n >= 12:
        fr.write("    jsr _sleep12\n")
        n = n - 12
    if n >= 4:
        fr.write("    jmp _sleepaux"+str(n)+"\n")
    else:
        for x in range(0, n):
            fr.write("    nop\n")
        fr.write("    rts\n")
    fm.write("sleep"+str(orign)+":    MACRO\n    jsr _sleep"+str(orign)+"\n    ENDM\n")
    return

if len(sys.argv) != 4:
    print ("Usage: makesleep input.asm sleepm.inc sleepr.inc")
    sys.exit(0)

input_asm = sys.argv[1]
sleepm_inc = sys.argv[2]
sleepr_inc = sys.argv[3]

sleepns = {}    
fin = open(input_asm, "rt")
while True:
    line = fin.readline()
    if not line:
        break
    # process line
    line = line.strip().split(';')[0].strip()
    if line.startswith("sleep") and line[5:].isdigit():
        sleepns[int(line[5:])] = 1
fin.close()
    
foutm = open(sleepm_inc, "wt")
foutr = open(sleepr_inc, "wt")

i = 12
foutm.write("sleep"+str(i)+":    MACRO\n    jsr _sleep"+str(i)+"\n    ENDM\n")
i = 16
while i <= 32768:
    foutm.write("sleep"+str(i)+":    MACRO\n    jsr _sleep"+str(i)+"\n    ENDM\n")
    i = i*2
foutm.write("\n")    

foutr.write(
"""_sleep32768:
    jsr _sleep16384
_sleep16384:
    jsr _sleep8192
_sleep8192:
    jsr _sleep4096
_sleep4096:
    jsr _sleep2048
_sleep2048:
    jsr _sleep1024
_sleep1024:
    jsr _sleep512
_sleep512:    
    jsr _sleep256
_sleep256:
    jsr _sleep128    
_sleep128:
    jsr _sleep64
_sleep64:
    jsr _sleep32
_sleep32:
    jsr _sleep16
_sleep16: 
    nop
    nop
    nop
    nop
_sleep12: ; jsr + rts = 12 cyc   
    rts

_sleepaux11:
    nop
_sleepaux10:   
    nop
_sleepaux9:    
    nop
_sleepaux8:    
    nop
_sleepaux7:    
    nop
_sleepaux6:    
    nop
_sleepaux5:    
    nop
_sleepaux4:
    rts
    
"""
    )

sleepns_sorted = sorted(sleepns.keys())
#print(sleepns_sorted)

for x in sleepns_sorted:
    write_sleepn(x, foutm, foutr)
    
foutm.close()    
foutr.close()



	


